
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float4 lP = POS0;
#ifdef sd_Animate
	lP = lerp ( POS0, POS1, Weight0 );
#endif

	float3 wP = (matW * lP).xyz;
	float3 wN = normalize(matW * float4(NOR0.xyz, 0.0)).xyz;
	float3 wE = normalize (EyePos - wP.xyz).xyz;
	
	float3 ambc = float3 (Ambient, Ambient, Ambient);// calc_hemisphere (wN, float3(0,0,1)/*sky*/, GrwColor, SkyColor, Ambient);
	float sun_diff = calc_diffuse (SunDir, wN, LambertPow);
	float sun_spec = calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
	float rim = 0.0;//calc_rimlight (SunDir, wN, wE, RimIntensity, RimBand);

#ifdef sd_Detail
	sun_spec = calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
#endif

	float3 diff = ambc.xyz + (sun_diff + rim + sun_spec) * SunColor;

#ifdef sd_Light
	diff += calc_point_light (wP, wN, PointLight0Pos, PointLight0Clr);
	diff += calc_point_light (wP, wN, PointLight1Pos, PointLight1Clr);
	diff += calc_point_light (wP, wN, PointLight2Pos, PointLight2Clr);

	//wP.xyz += diff * 0.01;

	//diff += calc_distance_light (wP, PointLight0Pos, PointLight0Clr);
	//diff += calc_distance_light (wP, PointLight1Pos, PointLight1Clr);
	//diff += calc_distance_light (wP, PointLight2Pos, PointLight2Clr);
#endif

#ifdef sd_Color
	diff += (CLR0.xyz * 5.0);
#endif

#ifdef sd_SeaRefl
	//wP.x += sin (wP.z * CTIME) * 0.15;
	//wP.y += sin (wP.z * CTIME) * 0.15;
#endif

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	float alpha = UserColor.w;
#ifdef sd_FogO
	float dist = calc_distance (EyePos, wP.xyz);
	float fog = 1.0 - get_dis_alpha (dist, FogNear, FogFar);
	alpha -= saturate(fog);
#endif
	vs_out_0 = float4 (diff*UserColor.xyz, alpha);
	vs_out_1 = float4 (TUV0.xy, wP.z, sun_spec);

#ifdef sd_Detail
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
#endif

#ifdef sd_Item
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
#endif

#ifdef sd_Decal
	vs_out_3 = c_mat3 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal2
	vs_out_4 = c_mat4 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal3
	vs_out_5 = c_mat5 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal4
	vs_out_6 = c_mat6 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal5
	vs_out_7 = c_mat7 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal6
	vs_out_8 = c_mat8 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal7
	vs_out_9 = c_mat9 * float4(wP.xyz, 1.0);
#endif

#ifdef sd_Decal8
	vs_out_10 = c_mat10 * float4(wP.xyz, 1.0);
#endif
}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define ColorKey		0.03
	#define DiffColor		ps_in_0.xyzw
	#define TexUV			ps_in_1.xy
	#define WPosZ			ps_in_1.z
	#define SunSpec			ps_in_1.w
	#define ReflUV			ps_in_2.xyz

void main () 
{ 
#ifdef sd_GlowX
	float4	pOut;
	vec4	texSamp;

#ifdef sd_Camo
	texSamp = mix(texture2D(c_samp0, TexUV), texture2D(c_samp6, TexUV) * c_parm23, c_parm23.a);
#else
	texSamp = texture2D(c_samp0, TexUV);
#endif

#ifdef sd_Decal
	vec4 projMapColor;
	vec3 diff = DiffColor.xyz;

	if ((ps_in_3.q < c_parm19.y) && (ps_in_3.q > c_parm19.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_3.xy / ps_in_3.w);

		if (c_parm19.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_3.xy / ps_in_3.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(texSamp * DiffColor, projMapColor, projMapColor.a * 0.9);
	}
	else
	{
		pOut = texSamp * DiffColor;
	}
#else
	pOut = texSamp * DiffColor;
#endif

#ifdef sd_Decal2
	if ((ps_in_4.q < c_parm20.y) && (ps_in_4.q > c_parm20.x))
	{
		projMapColor = texture2D(c_samp3, ps_in_4.xy / ps_in_4.w);

		if (c_parm20.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_4.xy / ps_in_4.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal3
	if ((ps_in_5.q < c_parm21.y) && (ps_in_5.q > c_parm21.x))
	{
		projMapColor = texture2D(c_samp4, ps_in_5.xy / ps_in_5.w);

		if (c_parm21.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_5.xy / ps_in_5.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal4
	if ((ps_in_6.q < c_parm22.y) && (ps_in_6.q > c_parm22.x))
	{
		projMapColor = texture2D(c_samp5, ps_in_6.xy / ps_in_6.w);

		if (c_parm22.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_6.xy / ps_in_6.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal5
	if ((ps_in_7.q < c_parm23.y) && (ps_in_7.q > c_parm23.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_7.xy / ps_in_7.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal6
	if ((ps_in_8.q < c_parm24.y) && (ps_in_8.q > c_parm24.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_8.xy / ps_in_8.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal7
	if ((ps_in_9.q < c_parm25.y) && (ps_in_9.q > c_parm25.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_9.xy / ps_in_9.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal8
	if ((ps_in_10.q < c_parm26.y) && (ps_in_10.q > c_parm26.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_10.xy / ps_in_10.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

	ps_out_c = pOut;

	//float4 texD = texture2D (c_samp0, TexUV );
	//float3 rcolor = texD.xyz * DiffColor.xyz + DiffColor.xyz * texD.w * SunSpec;
	//ps_out_c = float4 (rcolor.xyz, DiffColor.w);
#endif
	
#ifdef sd_GlowO
	float4	pOut;
	vec4	texSamp;

#ifdef sd_Camo
	texSamp = lerp(texture2D(c_samp0, TexUV), texture2D(c_samp6, TexUV) * c_parm23, c_parm23.a);
#else
	texSamp = texture2D(c_samp0, TexUV);
#endif
	float4 texD = texSamp.xyzw;
	texD.xyz *= DiffColor.xyz;
	texD.xyz += ( texD.xyz * GlowColor.xyz * texD.w );

#ifdef sd_Decal
	vec4 projMapColor;
	vec3 diff = DiffColor.xyz + (0.3 * GlowColor.xyz * texture2D(c_samp0, TexUV).w);

	if ((ps_in_3.q < c_parm19.y) && (ps_in_3.q > c_parm19.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_3.xy / ps_in_3.w);

		if (c_parm19.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_3.xy / ps_in_3.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(texD, projMapColor, projMapColor.a * 0.9);
	}
	else
	{
		pOut = float4(texD.xyz, DiffColor.w);
	}
#else
	pOut = float4(texD.xyz, DiffColor.w);
#endif

#ifdef sd_Decal2
	if ((ps_in_4.q < c_parm20.y) && (ps_in_4.q > c_parm20.x))
	{
		projMapColor = texture2D(c_samp3, ps_in_4.xy / ps_in_4.w);

		if (c_parm20.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_4.xy / ps_in_4.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal3
	if ((ps_in_5.q < c_parm21.y) && (ps_in_5.q > c_parm21.x))
	{
		projMapColor = texture2D(c_samp4, ps_in_5.xy / ps_in_5.w);

		if (c_parm21.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_5.xy / ps_in_5.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal4
	if ((ps_in_6.q < c_parm22.y) && (ps_in_6.q > c_parm22.x))
	{
		projMapColor = texture2D(c_samp5, ps_in_6.xy / ps_in_6.w);

		if (c_parm22.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_6.xy / ps_in_6.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal5
	if ((ps_in_7.q < c_parm23.y) && (ps_in_7.q > c_parm23.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_7.xy / ps_in_7.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal6
	if ((ps_in_8.q < c_parm24.y) && (ps_in_8.q > c_parm24.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_8.xy / ps_in_8.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal7
	if ((ps_in_9.q < c_parm25.y) && (ps_in_9.q > c_parm25.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_9.xy / ps_in_9.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal8
	if ((ps_in_10.q < c_parm26.y) && (ps_in_10.q > c_parm26.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_10.xy / ps_in_10.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif
	ps_out_c = pOut;

#endif

#ifdef sd_SeaRefl
	if (WPosZ < 0.0) discard;
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
#endif


#ifdef sd_Detail
	float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	float3 rcolor = lerp (texD.xyz, texR.xyz, ReflRatio);
	ps_out_c = float4 (rcolor.xyz*DiffColor.xyz, texD.w*DiffColor.w);
#endif

#ifdef sd_Item
	float4	pOut;
	vec4	texSamp;

#ifdef sd_Camo
	texSamp = lerp(texture2D(c_samp0, TexUV), texture2D(c_samp6, TexUV) * c_parm23, c_parm23.a);
#else
	texSamp = texture2D(c_samp0, TexUV);
#endif

	float4 texD = texSamp;
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	float3 rcolor = lerp (texD.xyz, texR.xyz, ps_in_2.w);

#ifdef sd_ItemGlow
	rcolor.xyz += (rcolor.xyz * GlowColor.xyz * texture2D(c_samp0, TexUV).w);
#endif

#ifdef sd_Decal
	vec4 projMapColor;
	vec3 diff = DiffColor.xyz;

#ifdef sd_ItemGlow
	diff += GlowColor.xyz * texture2D(c_samp0, TexUV).w * 0.3;
#endif

	if ((ps_in_3.q < c_parm19.y) && (ps_in_3.q > c_parm19.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_3.xy / ps_in_3.w);

		if (c_parm19.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_3.xy / ps_in_3.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(float4(rcolor.xyz*DiffColor.xyz, DiffColor.w), projMapColor, projMapColor.a * 0.9);
	}
	else
	{
		pOut = float4(rcolor.xyz*DiffColor.xyz, DiffColor.w);
	}
#else
	pOut = float4(rcolor.xyz*DiffColor.xyz, DiffColor.w);
#endif

#ifdef sd_Decal2
	if ((ps_in_4.q < c_parm20.y) && (ps_in_4.q > c_parm20.x))
	{
		projMapColor = texture2D(c_samp6, ps_in_4.xy / ps_in_4.w);

		if (c_parm20.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_4.xy / ps_in_4.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal3

	if ((ps_in_5.q < c_parm21.y) && (ps_in_5.q > c_parm21.x))
	{
		projMapColor = texture2D(c_samp4, ps_in_5.xy / ps_in_5.w);

		if (c_parm21.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_5.xy / ps_in_5.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal4
	if ((ps_in_6.q < c_parm22.y) && (ps_in_6.q > c_parm22.x))
	{
		projMapColor = texture2D(c_samp5, ps_in_6.xy / ps_in_6.w);

		if (c_parm22.z > 0.5)
		{
			vec4 oldTex = texture2D(c_samp7, ps_in_6.xy / ps_in_6.w);
			projMapColor = mix(projMapColor, 1.0 - oldTex, projMapColor.a * (1.0 - oldTex.r));
		}

		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal5
	if ((ps_in_7.q < c_parm23.y) && (ps_in_7.q > c_parm23.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_7.xy / ps_in_7.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal6
	if ((ps_in_8.q < c_parm24.y) && (ps_in_8.q > c_parm24.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_8.xy / ps_in_8.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

#ifdef sd_Decal7
	if ((ps_in_9.q < c_parm25.y) && (ps_in_9.q > c_parm25.x))
	{
		projMapColor = texture2D(c_samp2, ps_in_9.xy / ps_in_9.w);
		pOut = lerp(pOut, projMapColor, projMapColor.a * 0.9);
	}
#endif

	ps_out_c = pOut;

#endif

#ifdef sd_Shadow
	float4 texD = texture2D(c_samp0, TexUV).xyzw;
	float sum = 1.0 - saturate(texD.x + texD.y + texD.z);
	ps_out_c = float4(DiffColor.x, DiffColor.y, DiffColor.z, sum*DiffColor.w);
#endif

}

#endif







